unit browser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SBasic, StdCtrls, ExtCtrls, Grids, DBGrids, DB, DBTables, DBCtrls,
  Buttons, canvas, Watches;

type
  TBrowsForm = class(TForm)
    SBasic1: TSBasic;

    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;

    Table1: TTable;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;

    ExitButton: TButton;
    ExecButton: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Table1Key: TAutoIncField;
    Table1Title: TStringField;
    Table1Source: TBlobField;
    Table1Code: TBlobField;

    procedure ExecButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BrowsForm: TBrowsForm;

implementation

function FUNC_SET_COLOR( Data: TObject ): Real;
var  P1, P2, P3: ^real;
     R, G, B: integer;
begin
      P1 := Get_param( Data, 0, 0 );
      P2 := Get_param( Data, 1, 0 );
      P3 := Get_param( Data, 2, 0 );
      if (P1 <> nil) and (P2 <> nil) and (P3 <> nil) then
      begin
           R  := Round( P1^ );
           G  := Round( P2^ );
           B  := Round( P3^ );
           CanvasForm.Set_color( R, G, B );
      end;
      Result := 0;
end;

function FUNC_LINE( Data: TObject ): Real;
var  P1, P2, P3, P4: ^real;
     x1, x2, y1, y2: integer;
begin
      P1 := Get_param( Data, 0, 0 );
      P2 := Get_param( Data, 1, 0 );
      P3 := Get_param( Data, 2, 0 );
      P4 := Get_param( Data, 3, 0 );
      if (P1 <> nil) and (P2 <> nil) and (P3 <> nil) and (P4 <> nil) then
      begin
           x1 := Round( P1^ );
           y1 := Round( P2^ );
           x2 := Round( P3^ );
           y2 := Round( P4^ );
           CanvasForm.DrawLine( x1, y1, x2, y2 );
      end;
      Result := 0;
end;


function FUNC_PIXEL( Data: TObject ): Real;
var  P1, P2: ^real;
     x1, y1: integer;
begin
      P1 := Get_param( Data, 0, 0 );
      P2 := Get_param( Data, 1, 0 );
      if (P1 <> nil) and (P2 <> nil) then
      begin
           x1 := Round( P1^ );
           y1 := Round( P2^ );
           CanvasForm.DrawPixel( x1, y1 );
      end;
      Result := 0;
end;

function FUNC_ELLIPSE( Data: TObject ): Real;
var  P1, P2, P3, P4: ^real;
     x1, y1, R1, R2: integer;
begin
      P1 := Get_param( Data, 0, 0 );
      P2 := Get_param( Data, 1, 0 );
      P3 := Get_param( Data, 2, 0 );
      P4 := Get_param( Data, 3, 0 );
      if (P1 <> nil) and (P2 <> nil) and (P3 <> nil) and (P4 <> nil) then
      begin
           x1 := Round( P1^ );
           y1 := Round( P2^ );
           R1 := Round( P3^ );
           R2 := Round( P4^ );
           CanvasForm.DrawEllipse( x1, y1, R1, R2 );
      end;
      Result := 0;
end;

{$R *.DFM}

function GetExeDir: string;
var  i, N: integer;
begin
     Result := Application.ExeName;
     N := Length( Result );
     for i:=1 to Length( Result ) do
         if Result[i] = '\' then N := i;
     SetLength( Result, N );
end;

procedure TBrowsForm.FormCreate(Sender: TObject);
begin
     Table1.DataBaseName := GetExeDir;
     Table1.Active := true;
end;

procedure TBrowsForm.FormDestroy(Sender: TObject);
begin
     Table1.Active := false;
end;

procedure TBrowsForm.FormShow(Sender: TObject);
begin
     CanvasForm.SpeedButton1 := SpeedButton1;
     WatchForm.SpeedButton2  := SpeedButton2;
     WatchForm.SBasic1  := SBasic1;

     SBasic1.Watch_func  := WatchForm.FuncListBox;
     SBasic1.Watch_var   := WatchForm.VarListBox;
     SBasic1.Watch_const := WatchForm.ConstListBox;
     SBasic1.Watch_code  := WatchForm.CodeListBox;

     SBasic1.Add_function( 'SET_COLOR', FUNC_SET_COLOR, 3 );
     SBasic1.Add_function( 'LINE', FUNC_LINE, 4 );
     SBasic1.Add_function( 'PIXEL', FUNC_PIXEL, 2 );
     SBasic1.Add_function( 'ELLIPSE', FUNC_ELLIPSE, 4 );

     DBGrid1.SetFocus;
end;

procedure TBrowsForm.ExecButtonClick(Sender: TObject);
begin
     SBasic1.Clear_Data;
     if SBasic1.Translate = 0 then
     begin
          if not SpeedButton1.Down then
          begin
               CanvasForm.Show;
               CanvasForm.repaint;
               SpeedButton1.Down := true;
               update;
          end;
          CanvasForm.Clear_Canvas;
          SBasic1.Set_value( 'MAX_X', 0, CanvasForm.MAX_X-1 );
          SBasic1.Set_value( 'MAX_Y', 0, CanvasForm.MAX_Y-1 );
          SBasic1.Execute;
          SBasic1.Fill_Watches;
     end
end;

procedure TBrowsForm.ExitButtonClick(Sender: TObject);
begin
     Close;
end;

procedure TBrowsForm.SpeedButton1Click(Sender: TObject);
begin
     if SpeedButton1.Down then CanvasForm.Show
                          else CanvasForm.Close;
end;

procedure TBrowsForm.SpeedButton2Click(Sender: TObject);
begin
     if SpeedButton2.Down then WatchForm.Show
                          else WatchForm.Close;
end;

end.
